﻿* Encoding: UTF-8.
* This code is designed to create an NCANDS source data file. The NCANDS source datafile consists of multiple years of NCANDS child files with any additional variables for analyses added at the end. 
* The child files are combined using some python code that takes all the files in a spefied 

* Root folder for the data.
****PLEASE CHANGE THIS FILE PATH BASED ON WHERE YOU UNZIPED AND SAVED THE CFSR 3 FOLDER.****.
file handle Root_FH /name="C:\CFSR 3".

***DO NOT CHANGE FILE HANDLES BELOW****.
*Folder where the NCANDS Submissions need for the SourceData file are located.
file handle NCANDS_Source_FH  /name="Root_FH\0 - Source Data\Submissions NCANDS". 
*Folder for storing the combine child file and the combined DQ files.
file handle NCANDS_Comb_FH  /name="Root_FH\0 - Source Data". 
*Forlder that contains fixed files used in the DQ process.

file handle Fixed_FH /name= "Root_FH\1 - Fixed files".

*********************************************************************************************************************************************************************.
*Merge NCANDS Child Files.
*********************************************************************************************************************************************************************.
*This is small set of python code designed to loop through the a folder and merge all files that end with .sav. This code is run on the NCANDS Source Folder 
* (see: NCANDS_Source_FH) which is expected to contain all years of data to be examine. The end result will be a data file with all years of ncands to be analyzed.

begin program.
import spss, spssaux, os, glob

fh = spssaux.FileHandles()

rdir = fh.resolve('NCANDS_Source_FH')  # Specifies folder containing .sav files.
fils = sorted([fil for fil in os.listdir(rdir) if fil.endswith('.sav')])
spss.Submit('get file "%s/%s".'%(rdir,fils.pop(0)))
for rep in range(len(fils)/49 + 1):
    spss.Submit('add files file=*/%s.'%'/'.join(['file="%s"'%os.path.join(rdir,fil) for fil in fils[49*rep:49*rep + min(49,len(fils)-49*rep)]]))
spss.Submit('exe.')
end program.

dataset name SourceFile_NCANDS.
DATASET ACTIVATE SourceFile_NCANDS.
rename variables staterr=stateabb.
ALTER TYPE stateabb (A6).
SORT CASES by stateabb subyr.

*********************************************************************************************************************************************************************.
*Compute Victim Flag and remove unborn children from the analyses.
*********************************************************************************************************************************************************************.

* Flag victims, where a victim is a child who died due to maltreatment (maldeath = 1) or has a disposition of 
* substantiated (malNlevel = 1) or indicated (malNlevel = 2), for any of four possible maltreatments.
Compute flvictim = 0.
if ((mal1lev le 2) OR (mal2lev le 2) OR (mal3lev le 2) OR (mal4lev le 2) OR (maldeath = 1)) flvictim = 1.

*Remove unborn children from analysis. Unborn children have a code of 77 in the NCANDS data.
select if chage ne 77.
execute.
missing values chage (99).

*********************************************************************************************************************************************************************.
* Merge in State name and state abbreviation from a seperate file.
*********************************************************************************************************************************************************************.

get file='fixed_FH/states.sav'
/keep statetxt stateabb  state.
DATASET NAME STATES.
DATASET ACTIVATE STATES.

sort cases by stateabb.

match files 
   /file = SourceFile_NCANDS 
   /table = STATES
   /by stateabb.
execute.
DATASET Close States.

*********************************************************************************************************************************************************************.
* Save the NCANDS source data
*********************************************************************************************************************************************************************.

dataset name SourceFileNCANDS.
DATASET Close SourceFile_NCANDS. 
DATASET ACTIVATE SourceFileNCANDS.
SAVE OUTFILE = 'NCANDS_Comb_FH\CFSR 3 NCANDS source data.zsav'  /ZCOMPRESSED..










