﻿* Encoding: UTF-8.
*************************************
CFSR 3 Observed Performance for Maltreatment in Care
**************************************

*The file handle Root_FH represents the root folder for the CFSR data. ****PLEASE CHANGE THIS FILE PATH BASED ON WHERE YOU UNZIP AND SAVE THE CFSR 3 FOLDER.****.
file handle Root_FH /name="C:\CFSR 3".
*The file handle NCANDS_Comb_FH is the input folder for this code. It should contain the combined NCANDS source files produced by earlier code.
file handle NCANDS_Comb_FH  /name="Root_FH\0 - Source Data". 
*The file handle AFCARS_Comb_FH is the input folder for this code. It should contain the combined AFCARS source files produced by earlier code.
file handle AFCARS_Comb_FH  /name="Root_FH\0 - Source Data". 
file handle NCANDS_DQ_FH /name= "Root_FH\2 - DQ NCANDS".
file handle AFCARS_DQ_FH /name= "Root_FH\2 - DQ AFCARS".
file handle SpssLogs_FH /name="Root_FH\5 - SPSS Logs". 
file handle Syntax_FH /name="Root_FH\0 - Syntax".
file handle Temp_FH /name= "Root_FH\0 - Temp files".
file handle Splits_FH /name="Temp_FH\Splits".
file handle Output_Child_FH /name="Root_FH\3 - Performance observed child".
file handle Output_State_FH /name="Root_FH\3 - Performance observed state".


* Open AFCARS source data.
get file 'root_FH\0 - Source Data\CFSR 3 AFCARS source data.sav'
/keep state fipscode recnumbr sex totalrem numplep curplset disreasn ChildID statetxt stateabb DtReportBeg DtReportEnd DtReportEndFinal DtBirth
DtFirRem DtPriorDisch DtLatRem DtCurSet DtDisch FY afcarsid AgeNmos AgeNmosyrsCat AgeNyrs AgeNmosyrs  ExAge18 Bday18 Adjust18
DtDischAdjusted DQ_Dropped DQ_IDNoMatchNext6Mo DQ_missDOB DQ_missDtLatRem DQ_missNumPlep DQ_DOBgtDtLatRem DQ_DOBgtDtDisch DQ_DtDischeqDtLatRem
DQ_DtDischltDtLatRem DQ_missDisreasn DQ_totalrem1 DQ_gt21DOBtoDtLatRem DQ_gt21DOBtoDtDisch DQ_gt21DtDischtoDtLatRem DQ_dtpriordafterdlm 
EntryYr ExitYr AgeXmos AgeXmosyrsCat AgeXyrs AgeXmosyrs TRemCat chrace race racethnc.
dataset name Indicator window=front.
cache.


****************************************************
* SPECIFY THE 12-MONTH COHORT WHOSE OUTCOME WILL BE ASSESSED *****MANUAL INPUT REQUIRED HERE******
****************************************************

* Identify the 12-month cohort of interest (e.g., children in care during 13A13B) by entering "AB"  for 
* PeriodType and the year the 12-month period ends (for YYYY and YYstr).

* Since this code is designed to use ncands and afcars files, and they only line up when using "AB" files,
* the code should not be run with a periodtype of "BA".

* AB period (A file + B file) spans Oct 1 - Sept 30 of the following year.
* BA period (B file + A file) spans Apr 1 - Mar 31 of the following year.

* Examples:
* ( * ) represents a FY
* Children in care during   PeriodType  YYYY   YYstr
* 10A10B *                      AB              2010     10
* 11A11B *                      AB              2011     11
* 12A12B *                      AB              2012     12 
* 13A13B *                      AB              2013     13
* etc.

********  START USER INPUT ********

define PeriodType () "XX"
!enddefine.
define YYYY () XXXX.   
!enddefine.
define YYstr () "XX" 
!enddefine. 

********  END USER INPUT ********

* Create variable that indicates the user-specified 12-month cohort (e.g., "AB13" represents "13A13B").
string TwelveMoCohort (A4).
compute TwelveMoCohort = concat(PeriodType,YYstr).
execute.

****************************************************
CREATE DATE PARAMETERS
****************************************************

* Start date of a 12-month period (10/1/YYYY or 4/1/YYYY).
* End date of a 12-month period (3/31/YYYY or 9/30/YYYY).

* Maltreatment in foster care involves following children who were served during the 12-month period specified 
* earlier. Served includes children who entered care during the period, or were in care on the first day of the 
* period. Identify the start date (DtPeriodBeg) and end date (DtPeriodEnd) that defines this 12-month period. 
*ALL ANALYSIS PERIODS ARE AB FOR MALTREATMENT IN CARE.

compute DtPeriodBeg=date.mdy(10,01,YYYY-1).
compute DtPeriodEnd=date.mdy(09,30,YYYY).
compute DtEndFirst6mo=date.mdy(03,31,YYYY).
EXECUTE.
formats DtPeriodBeg DtPeriodEnd DtEndFirst6mo(adate10).

variable labels 
TwelveMoCohort '12-month period children were served and for whom performance is being assessed'
DtPeriodBeg 'Start date of the 12-month period specified'
DtPeriodEnd 'End date of the 12-month period specified'.

****************************************************
* REMOVE STATES THAT EXCEED DQ LIMITS FOR THE AFCARS DQ CHECKS
****************************************************

* The AFCARS cross-file checks (Dropped records and AFCARS IDs don't match from one period to the next)
* apply only to the first 6-month period (DtReportBeg = DtPeriodBeg). The AFCARS within-file checks apply to 
* both periods (DtReportBeg ge DtPeriodBeg AND DtReportBeg le DtPeriodEnd). The NCANDS DQ checks
* will be applied later.

* Open AFCARS data quality results.
get file 'AFCARS_DQ_FH\Merged AFCARS DQ files.sav'.
dataset name DQResults window=front.

* Prevent accidentally overwriting file.
dataset copy  DQIndicator.
dataset activate DQIndicator.
dataset close DQResults.

do if PeriodType = "AB".
compute DtPeriodBeg=date.mdy(10,01,YYYY-1).
compute DtPeriodEnd=date.mdy(09,30,YYYY).
end if.

execute.
formats DtPeriodBeg DtPeriodEnd (adate10).

variable labels 
DtPeriodBeg 'Start date of the 12-month period specified'
DtPeriodEnd 'End date of the 12-month period specified'.


* Select the AFCARS checks for this indicator and DQ results for the 6-month period(s).
* ... Cross file checks (apply only to the first 6-month period).
if MALFC = 1 and DQFileXW = "Cross file" AND (DtReportBeg eq DtPeriodBeg) DQChecksApply = 1.
* ... Within file checks (apply to both 6-month periods).
if MALFC = 1 and DQFileXW = "Within file" AND (DtReportBeg ge DtPeriodBeg) and (DtReportEnd le DtPeriodEnd) DQChecksApply = 1.
execute.

* For each state, for the checks that apply, sum the number of checks it failed.
select if DQChecksApply = 1.
execute.


DATASET DECLARE DQStateInd.
aggregate
  /OUTFILE=DQStateInd
  /BREAK=stateabb
  /DQFailedCheck_sum=SUM(DQFailedCheck).
dataset activate DQStateInd.
dataset close DQIndicator.
sort cases by stateabb.

get file 'NCANDS_DQ_FH\Merged NCANDS DQ files.sav'.
dataset name DQResultsN window=front.
cache.
* Prevent accidentally overwriting file.
dataset copy  DQIndicatorN.
dataset activate DQIndicatorN.
dataset close DQResultsN.


if ((malFC eq 1) and (subyr ge YYYY) AND (subyr le (YYYY+1))) DQchecksApplyN =1. 
sort cases by stateabb.
select if DQChecksApplyn = 1.
execute.


DATASET DECLARE DQIndicatorN2.
aggregate
  /OUTFILE=DQIndicatorN2
  /BREAK=stateabb
  /DQFailedCheckN_sum=SUM(DQFailedCheck).

match files 
    /FILE='DQStateInd'
    /FILE='DQIndicatorN2' 
    /BY stateabb.
execute.

dataset name DQIndicators.
dataset activate DQIndicators.
dataset close DQStateInd.
dataset close DQIndicatorN.
dataset close DQIndicatorN2.

sort cases by stateabb.
* ... Merge in all variables from DQIndicator file, then keep only DQFailedCheck_sum. 
dataset activate Indicator.
sort cases by stateabb.
execute.
match files 
    /FILE=*
    /TABLE='DQIndicators' 
    /BY stateabb
    /KEEP state to DQFailedCheckN_sum.
execute.

dataset close DQIndicators.

* Select only states that met the DQ checks.
select if DQFailedCheck_sum eq 0 AND DQFailedCheckN_sum eq 0.
execute.
delete variables DQFailedCheck_sum DQFailedCheckN_sum.

if DtReportEnd eq DtPeriodEnd DQ_Dropped = 0.
execute.

* Flag records with a problem (i.e., = 1) for any of the AFCARS DQ checks used for Maltreatment in foster care, 
* except DQ_IDNoMatchNext6Mo and DQ_totalrem1. The NCANDS DQ checks will be applied later.
compute DQ_Indicator=0.
if any(1,DQ_DOBgtDtDisch, DQ_DOBgtDtLatRem, DQ_Dropped, DQ_DtDischeqDtLatRem, DQ_DtDischltDtLatRem, DQ_gt21DOBtoDtDisch, DQ_gt21DOBtoDtLatRem, DQ_gt21DtDischtoDtLatRem, DQ_missDOB, DQ_missDtLatRem, DQ_dtpriordafterdlm) DQ_Indicator=1.  
execute.

select if DQ_Indicator=0.
execute.

*Select only records reported during the period of interest for the analysis.
if (DtReportBeg ge DtPeriodBeg) and (DtReportEnd le DtPeriodEnd) ReportedDuringPeriod = 1.
execute.

select if ReportedDuringPeriod=1.
execute.
****************************************************

* For maltreatment in foster care, all of a child's episodes during the 12-month period are considered. 
* For example, if a child has two entries in the 12-month period, data from both episodes are used.

* Select only the most recent 6-month record reported for each child, for each episode.
****************************************************

* This will create an episode-level file. Episodes are distinguished by the date of latest removal from home. 
* A child has a record in each 6-month submission until he discharged, dropped, or was still in care as of 
* the last reporting period we have in the file. We only want one record per child, per episode, and the record we
* pick is the last one reported for that episode. This record will contain the most recent data available that 
* describes the child's episode (e.g., LOS, age, etc.). 

* Flag the records to keep.
sort cases BY ChildID (A) DtLatRem (A).
match files
  /FILE=*
  /BY ChildID DtLatRem
  /LAST=Flag_LastRpt4Ep.
variable labels Flag_LastRpt4Ep 'last 6-month report we received for this episode (based on DtLatRem)'.
value labels Flag_LastRpt4Ep 0 'Duplicate Case' 1 'Primary Case'.
variable level Flag_LastRpt4Ep (ORDINAL).
execute.

* Select the last 6-month record for each child, for each episode. 
select if Flag_LastRpt4Ep=1.
execute.

delete variables Flag_LastRpt4Ep.



* Create InAtStart, Entered, and Served Variables. Select only children who were served during the 12-month period specified earlier. 
****************************************************

* This is the cohort of children for whom performance will be examined.

if ((DtLatRem lt DtPeriodBeg) and (DtDisch ge (DtPeriodBeg) | missing(DtDisch))) InAtStart = 1.
if ((DtLatRem ge DtPeriodBeg) and (DtLatRem le DtPeriodEnd)) Entered = 1.
if (InAtStart = 1 or Entered = 1) Served = 1.
recode InAtStart Entered (sysmis = 0).
execute.

variable labels 
InAtStart 'Child was in care on the first day of the 12-month period'
Entered 'Child entered care during the specified 12-month period'.
value labels InAtStart Entered 
0 'No'
1 'Yes'. 
execute.

* Select the records to keep. 
select if Served = 1.
execute.

****************************************************
* ADJUST DISCHARGE DATES FOR YOUTH WHO TURN 18
****************************************************

* Youth who turn 18 during the 12-month period will not have time in care beyond their 18th birthday or 
* victimizations after their 18th birthday counted. To handle this, for children who turn 18 during the period we 
* replace their discharge date with the date they turned 18. Therefore, the LOS for children who turn 18 during 
* the period will be calculated from date of latest removal to date of 18th birthday.
****************************************************

* Calculate child's 18th birthday. 
compute Bday18=DATESUM(DtBirth, 18, "years", 'closest').
variable labels  Bday18 "18th birthday".
variable level Bday18(SCALE).
formats Bday18(ADATE10).
variable width Bday18(10).
execute.

* If 18th birthday occurred during the 12-month period, and child had not discharged by the time he turned 18, 
* replace date of discharge with date of 18th birthday.

do if (Bday18 ge DtPeriodBeg and Bday18 le DtPeriodEnd) and (missing(DtDisch) or DtDisch gt Bday18).
compute DtDischAdjusted=Bday18.
compute Adjust18=1.
end if.
execute.
variable labels DtDischAdjusted 'For children who turned 18 during the period and had not discharged by that time, the date of their 18th birthday is their effective date of discharge'.

* Copy date of discharge for remaining children to DtDischAdjusted. This will put the date of discharge that we want to use for every child in the DtDischAdjusted variable.
do if sysmis(DtDischAdjusted).
compute DtDischAdjusted=DtDisch.
end if.
execute.
formats DtDischAdjusted (adate10).

****************************************************
* CALCULATE AGE ON FIRST DAY
****************************************************

* If child entered during the 12-month period, we use age entry (already calculated and part of source data).
* If the child was in care on the first day of the 12-month period, we use age on first day. 

* Age on first day (categorical), specified as 0-3 mos, 4-11 mos, 1-5 yrs, 6-10 yrs, 11-16 yrs, 17, 18-21 yrs. 
* Useful for reporting and descriptive statistics. 
********************************

* Calculate age on first day in months.
compute AgeFDmos = datediff(DtPeriodBeg,DtBirth,"months").
* Record age in months to desired categories.
recode AgeFDmos (216 thru 263=6) (204 thru 216=5) (132 thru 204=4) (72 thru 132=3) (12 thru 72=2) (4 thru 12=1) (0 thru 4=0) (else=sysmis) into AgeFDmosyrsCat.
execute.

* Age on first day (interval), specified as 0-3 mos, 4-11 mos, 1 yr ... 21 yrs. 
* Used later in risk adjustment, where each age value is converted to a yes/no (1/0) dummy variable. 
********************************

* Calculate age on first day in years.
compute AgeFDyrs = datediff(DtPeriodBeg,DtBirth,"years").
* Children < 1 currently have a value of 0 for AgeFDyrs. Need to split these into 0-3 mos (0) mos and 4-11 mos (1). 
* To make room for the 0 and 1 for < 1 children, make a copy of AgeFDyrs then shift all subsequent ages, so age1 = 2, age2 = 3, etc. 
compute AgeFDmosyrs = AgeFDyrs.
* Recode 1 - 21 to 2 - 22. 
recode AgeFDyrs (1=2) (2=3) (3=4) (4=5) (5=6) (6=7) (7=8) (8=9) (9=10) (10=11) (11=12) (12=13) (13=14) (14=15) (15=16) (16=17) (17=18) (18=19) (19=20) (20=21) (21=22) INTO AgeFDmosyrs.
* If child is 0-3, make AgeFDmosyrs = 0.
* If child is 4-11, make AgeFDmosyrs = 1.
if AgeFDmosyrsCat = 0 AgeFDmosyrs = 0.
if AgeFDmosyrsCat = 1 AgeFDmosyrs = 1.
execute. 

* Handle problem values.
********************************

* If date of birth is after the date of first day (i.e., age on FS is negative), recode to 8888.
* Note: Negative age on first day is to be expected for children who entered during the 12-month period at age 
* < 1. For these children, their age at entry will be selected so it's okay to assign their age on first day to 8888.
do if DtBirth > DtPeriodBeg. 
recode AgeFDmos AgeFDyrs AgeFDmosyrsCat AgeFDmosyrs (else = 8888).
end if.
* If time between date of birth and date of first day is > 21 yrs (i.e., age on FD is > 21 yrs), recode to 8888.
compute #AgeFD = datediff(DtPeriodBeg,DtBirth,"years").
do if #AgeFD > 21. 
recode AgeFDmos AgeFDyrs AgeFDmosyrsCat AgeFDmosyrs (else=8888).
end if.
execute.

variable labels 
AgeFDmos 'Age on first day in months' 
AgeFDyrs 'Age on first day in years (Under 1, 1, 2, 3 ... 21)' 
AgeFDmosyrs 'Age on first day in months (0-3 mo, 4-11 mo) and years (1, 2, 3 ... 21)' 
AgeFDmosyrsCat 'Age on first day in months (0-3 mo, 4-11 mo) and years in categories (1-5, 6-10, etc...)'.

* Create macro that holds age values.
DEFINE !AgeYrs ( )  
0 '< 1 yr'
1 '1 yr'
2 '2 yrs'
3 '3 yrs'
4 '4 yrs'
5 '5 yrs'
6 '6 yrs'
7 '7 yrs'
8 '8 yrs'
9 '9 yrs'
10 '10 yrs'
11 '11 yrs'
12 '12 yrs'
13 '13 yrs'
14 '14 yrs'
15 '15 yrs'
16 '16 yrs'
17 '17 yrs'
18 '18 yrs'
19 '19 yrs'
20 '20 yrs'
21 '21 yrs'
!ENDDEFINE.

DEFINE !AgeMosYrs ( )  
0 '0-3 mos'
1 '4-11 mos'
2 '1 yr'
3 '2 yrs'
4 '3 yrs'
5 '4 yrs'
6 '5 yrs'
7 '6 yrs'
8 '7 yrs'
9 '8 yrs'
10 '9 yrs'
11 '10 yrs'
12 '11 yrs'
13 '12 yrs'
14 '13 yrs'
15 '14 yrs'
16 '15 yrs'
17 '16 yrs'
18 '17 yrs'
19 '18 yrs'
20 '19 yrs'
21 '20 yrs'
22 '21 yrs'
!ENDDEFINE.

DEFINE !AgeMosYrsCat ( )  
0 '0-3 mos' 
1 '4-11 mos'
2 '1-5 yrs'
3 '6-10 yrs'
4 '11-16 yrs'
5 '17'
6 '18-21 yrs'
!ENDDEFINE.

* Age on first day.
value labels 
AgeFDmos
8888 'Invalid (age is negative or > 21)'
9999 'Cannot calculate (DOB missing)'
/AgeFDyrs 
!AgeYrs 
8888 'Invalid (age is negative or > 21)'
9999 'Cannot calculate (DOB missing)'
/AgeFDmosyrs 
!AgeMosYrs 
8888 'Invalid (age is negative or > 21)'
9999 'Cannot calculate (DOB missing)'
/AgeFDmosyrsCat
!AgeMosYrsCat 
8888 'Invalid (age is negative or > 21)'
9999 'Cannot calculate (DOB missing)'.

formats AgeFDmos to AgeFDmosyrs (F2.0).

****************************************************
* SET CHILD'S AGE AS AGE AT ENTRY OR AGE ON FIRST DAY
****************************************************

* If child entered during the 12-month period, set age to age at entry.
* If child was in care on the first day of the 12-month period, set age to age on first day. 

do if Entered=1.
compute Agemos=AgeNmos.
compute AgemosyrsCat=AgeNmosyrsCat.
compute Ageyrs=AgeNyrs.
compute Agemosyrs=AgeNmosyrs.
end if.
do if InAtStart=1.
compute Agemos=AgeFDmos.
compute AgemosyrsCat=AgeFDmosyrsCat.
compute Ageyrs=AgeFDyrs.
compute Agemosyrs=AgeFDmosyrs.
end if.
execute.

variable labels 
Agemos 'Age on first day (or at entry) in months'
Ageyrs 'Age on first day (or at entry) in years (Under 1, 1, 2, 3 ... 21)' 
Agemosyrs 'Age on first day (or at entry) in months (0-3 mo, 4-11 mo) and years (1, 2, 3 ... 21)'
AgeNmosyrsCat 'Age on first (or at entry) in months (0-3 mo, 4-11 mo) and years in categories (1-5, 6-10, etc...)'.

value labels 
Agemos
8888 'Invalid (age is negative or > 21)'
/Ageyrs 
!AgeYrs 
8888 'Invalid (age is negative or > 21)'
/Agemosyrs 
!AgeMosYrs 
8888 'Invalid (age is negative or > 21)'
/AgemosyrsCat
!AgeMosYrsCat 
8888 'Invalid (age is negative or > 21)'.

formats Agemos to Agemosyrs (F2.0).

****************************************************
* CALCULATE LENGTH OF STAY
****************************************************

* LOS calculations differ based on when the children was in care (i.e., on the first day of or entered during the 
* 12-month period) and when the child exited (i.e., during the 12-month period or after, if at all). 

* We already have a flag to indicate if the child was InAtStart or Entered. Now create a flag to indicate if the
* child exited during the 12-month period.

*SPECIAL CALCULATIONS AND CONSIDERATIONS FOR CHILDREN WITH MORE THAN ONE EPISODE IN THE 12-MONTH PERIOD OF INTEREST.

*Flag any episode that is not a child's first episode of the year.
sort cases by ChildID dtreportbeg.
if (childid eq lag(childid)) duplicate_child=1.
execute.

*Label each episode to indicate if it is a child's first or second episode. 
compute position=1.
if (duplicate_child=1) position = lag(position)+1. 
execute.

if missing(duplicate_child) duplicate_child eq 0.
execute.

*create child-level flag for children with multiple epiosdes.

aggregate 
outfile=* mode=ADDVARIABLES
/break state childid
/dupchild = max(duplicate_child).


*For each record take the dtpriordisch from the subquent episode and create variable to hold it.

PRESERVE.
set workspace 200000.
create TempDtPriorDisch=Lead(DtPriorDisch,1).
execute.
RESTORE.

*For each episode, take total number of removals from next episode and creat variable to hold it. 
PRESERVE.
set workspace 200000.
create nexttotrem=Lead(totalrem,1).
execute.
RESTORE.

*Compute the change in the total number of removals between reported episodes for children who have multiple episodes.
if (dupchild=1 and position=1) changerem = (nexttotrem - totalrem).
execute.


compute ExMissingDOD=0.
compute ExMissingPriorDOD=0.
EXECUTE.

*Set  DtDischNextRecord as TempDtPriorDisch in first record if child has more than one episode, total number of removals only increased by 1, and the tempdtpriordisch occurs after the date of removal for the first episode reported in the period. 
*If child turns 18, only set  DtDischNextRecord as TempDtPriorDisch if it occured before the child's 18th birthday.
*Change DtDischAdjusted to DtDischNextRecord where applicable.

if dupchild=1 and position=1 and adjust18 eq 1 and changerem eq 1 and tempdtpriordisch ge dtlatrem and (TempDtPriorDisch lt DtDischAdjusted) AND (DtDischAdjusted eq Bday18) DtDischNextRecord = TempDtPriorDisch.
if dupchild=1 and position=1 and missing(DtDischAdjusted) AND changerem eq 1 and tempdtpriordisch ge dtlatrem and adjust18 ne 1 DtDischNextRecord=TempDtPriorDisch.
execute.
if (DtDischNextRecord ge dtperiodbeg and DtDischNextRecord le DtPeriodEnd) DtDischAdjusted=DtDischNextRecord.
execute.


*Drop first record if child has more than one episode, the number of removals between the first record and the second record changes by more than one, and we do not have a valid dtdisch reported. 
compute drop_changerem =0.
if dupchild eq 1 and position eq 1 and changerem ne 1 and missing(dtdisch) drop_changerem = 1.
execute.
select if drop_changerem ne 1.
execute.


****************************************************
* CALCULATE LENGTH OF STAY
****************************************************

* LOS calculations differ based on when the children was in care (i.e., on the first day of or entered during the 
* 12-month period) and when the child exited (i.e., during the 12-month period or after, if at all). 

* We already have a flag to indicate if the child was InAtStart or Entered. Now create a flag to indicate if the child exited during the 12-month period.
if ((DtDischAdjusted ge DtPeriodBeg) and (DtDischAdjusted le DtPeriodEnd)) Exited = 1.
recode Exited (sysmis = 0).
execute.
variable labels Exited 'Child exited care during the specified 12-month period'.
value labels Exited
0 'No'
1 'Yes'.
execute.

compute LOSdays = $sysmis.
* If child entered and exited during the 12-month period, LOS is time between DtLatRem and DtDischAdjusted.
do if Entered=1 and Exited=1. 
compute LOSdays=datediff(DtDischAdjusted,DtLatRem,"days").
end if.
* If child was in care at the start of the 12-month period, and exited during the 12-month period, LOS is time 
* between DtPeriodBeg and DtDischAdjusted.
do if InAtStart=1 and Exited=1.
compute LOSdays=datediff(DtDischAdjusted,DtPeriodBeg,"days").
end if.
* If child entered during the 12-month period, and did not exit during the 12-month period, LOS is time between
* DtLatRem to DtPeriodEnd.
do if Entered=1 and Exited=0. 
compute LOSdays=datediff(DtPeriodEnd,DtLatRem,"days").
end if.
* If child was in care at the start of the 12-month period, and did not exit during the 12-month period, LOS is 
* time between DtPeriodBeg and DtPeriodEnd. These children were in care continuously across the entire year,
* so we add a day to their LOS. Otherwise, SPSS does not count inclusive of the start and end dates.
do if InAtStart=1 and Exited=0.
compute LOSdays=datediff(DtPeriodEnd,DtPeriodBeg,"days").
compute LOSdays=LOSdays+1.
end if.
execute.

variable labels 
LOSdays 'LOS - Days in care during the 12-month period'.
formats LOSdays (F4.0).

****Remove records that do not have a valid discharge date reported in dtdischadjusted or dtpriordisch from next record for children with 2 records that have different dtlatrem.

sort cases by ChildID dtreportbeg.
if (dtlatrem ne lag(dtlatrem) AND childID eq lag(ChildID) and (missing(lag(dtdischadjusted)) OR lag(Adjust18) eq 1)) flagCase eq 1.
execute.

if flagcase eq 1 AND ((missing(dtpriordisch)) or dtpriordisch lt dtperiodbeg) flagcase2 eq 1.
execute.

aggregate
  /OUTFILE=* MODE=ADDVARIABLES
  /BREAK=ChildID
  /Flagrptremove2 = max(flagcase2).


compute dropreport eq 0.
if (flagrptremove2 eq 1 AND position eq 1) dropreport eq 1.
execute.


select if dropreport ne 1.
execute.

***DROP first record/episode if multiple records/episodes are reported for a child and they contain conflicting/overlapping information.

if childid eq lag(childid) AND dtlatrem lt lag(dtdisch) AND not(missing(lag(dtdisch))) overlapep eq 1. 
execute. 


aggregate
  /OUTFILE=* MODE=ADDVARIABLES
  /BREAK=ChildID
  /overlapepchild = max(overlapep).

compute dropoverlap eq 0.
if (overlapepchild eq 1 AND position eq 1) dropoverlap = 1.
execute.

select if dropoverlap eq 0.
execute.

****************************************************
* REMOVE EPISODES THAT MEET EXCLUSION CRITERIA
****************************************************

* The denominator for this indicator is the sum of children's LOS (days) across *all* episodes during the 
* 12-month period. So if a child entered twice during the 12-month periods, his total LOS is the LOS from his
* first episode plus the LOS from his second episode. However, when summing a child's LOS over all his 
* episodes in the 12-month period, we want to exclude:
* 1) episodes in which the child entered at age 18 or more and
* 2) *complete* episodes with LOS < 8 days. If the episode has a LOS < 8 days, but the child is still in care, 
* we want to keep this. These short but ongoing episodes represent entries that occurred near the end of the 
* 12-month period and continued past it (i.e., child was still in care).

* Complete episodes with LOS < 8 days.
compute ExLOS8 = 0.
if (Entered=1 and Exited=1) and LOSdays lt 8 ExLOS8=1.
do if InAtStart=1 and Exited=1. 
compute TempLOS8= datediff(DtDischAdjusted,DtLatRem,"days").
if TempLOS8 lt 8 ExLOS8=1.
end if.
execute.

* Age at entry or on first day is 18 or older.
compute ExAge18 = 0.
if AgemosyrsCat = 6 ExAge18 = 1.
execute.
* Age at entry or on first day is invalid (negative or > 21).
if AgemosyrsCat = 8888 ExAge18 = 8888.
execute.

variable labels 
ExLOS8 'Episode has a LOS < 8 days'
ExAge18 'Child was age 18 or older at entry or on first day'.

value labels ExLOS8 
0 'No'
1 'Yes'
8888 'Cannot be determined because LOS is negative or > 21'
/ ExAge18 
0 'No'
1 'Yes'
8888 'Cannot be determined because age is negative or > 21'.
execute.

formats ExLOS8 ExAge18 (F1.0).


* Select the records to keep (i.e., 0 for both vars).   
select if (ExLOS8 = 0 and ExAge18 = 0).
execute.
select if ExMissingDOD=0 and ExMissingPriorDOD=0.
EXECUTE.
****************************************************
* SUM EACH CHILD's LOS ACROSS EPISODES
****************************************************

sort cases BY ChildID.
aggregate 
  /OUTFILE=* MODE=ADDVARIABLES 
  /PRESORTED
  /BREAK=ChildID
  /Den_Child=SUM(LOSdays).

variable labels Den_Child 'Maltreatment in care denominator - Childs total length of stay (days) across all episodes in the 12-month period'.
formats Den_Child (F3.0).
execute.

*flag children whose number of days in care for the year are greater than 365.

if den_child gt 365 over365 eq 1.
execute.
****************************************************

* These are due to data quality issues associated with some children who were reported two or more times 
* during the 12-month period, with different dates of latest removal, and with no date of discharge in the first 
* reported episode. 


compute flagDCover = 0.
if Den_child gt 365 flagDCover = 1.
execute.

do if (Den_Child gt 366 AND (DtPeriodEnd=date.mdy(9,30,2012) or DtPeriodEnd=date.mdy(3,31,2012) or DtPeriodEnd=date.mdy(9,30,2016) or DtPeriodEnd=date.mdy(3,31,2016) or DtPeriodEnd=date.mdy(9,30,2020) or DtPeriodEnd=date.mdy(3,31,2020))).
compute Den_Child=366.
end if. 
EXECUTE.
do if (Den_Child gt 365 AND (DtPeriodEnd<>date.mdy(9,30,2012) and DtPeriodEnd<>date.mdy(3,31,2012) and DtPeriodEnd<>date.mdy(9,30,2016) and DtPeriodEnd<>date.mdy(3,31,2016) and DtPeriodEnd<>date.mdy(9,30,2020) and DtPeriodEnd<>date.mdy(3,31,2020))).
compute Den_Child=365.
end if.
execute.



* Some children may have a total LOS = 0 days. 
****************************************************

* These are children who exited on the first day of the 12-month period, or entered on the last day of the
* 12-month period. At these points, they have not been in care during the 12-month period for a full 24 hours. 
* In addition, victimization rates for these children cannot be calculated when their LOS (i.e., denominator) is 0.

select if Den_Child <> 0.
execute.

****************************************************
* FINAL PREP OF AFCARS DATA
****************************************************

* Count the number of episodes. Maximum number should be 2 (one for each 6-month reporting period). 
sort cases by ChildID DtLatRem.
compute numepisodes = 1.
if (ChildID = lag(ChildID))numepisodes = lag(numepisodes) + 1.
execute.

* This indicator excludes any maltreatment report that occurs within 7 days of removal from home (DtLatRem). 
* Therefore, compute DtLatRemPlus7 to be the removal date plus seven days. This will be used for later to
* exclude maltreatment reports in NCANDS that occured before DtLatRemPlus7. 


compute DtLatRemPlus7 =datesum(DtLatRem, 7, "days"). 
execute.
formats DtLatRemPlus7 (adate10).
variable labels DtLatRemPlus7 'Childs date of latest removal plus 7 days'.

* Later we need to find only maltreatment reports that occurred after the date of latest removal and before
* the date of discharge. If the the child is still in care at the end of the 12-month period, his DtDisch is missing, 
* in which case we use DtPeriodEnd as the effective date of discharge. 

if sysmis(DtDischAdjusted) DtDischAdjusted2=DtPeriodEnd.
if sysmis(DtDischAdjusted2) DtDischAdjusted2=DtDischAdjusted.
execute.
formats DtDischAdjusted2 (adate10).

variable labels DtDischAdjusted2 'Discharge date used for NCANDS matching. For children who did not exit during the 12-month period, DtPeriodEnd is their effective date of discharge'.

* Save.
save outfile= 'Temp_FH\Maltx FC 1 AFCARS duplicated ' + PeriodType + YYstr + '.sav' 
  /keep = state stateabb statetxt TwelveMoCohort recnumbr ChildID Ageyrs Agemosyrs AgemosyrsCat sex DtLatRemPlus7 DtDischAdjusted2 Den_Child.
dataset name AFCARSDuplicated.

* Restructure AFCARS data from long to wide (one record per child)
****************************************************

* Current AFCARS file has one record per episode during the 12-month period, so a child with two episodes 
* has two records. This new file will contain one record per child, with all of his episode information on one 
* record, indexed by N. For example: state ChildID recnumbr DtDischAdjusted.1 DtDischAdjusted.2 ... etc. 
* We will later match this file with NCANDS (matching on recnumbr, which in NCANDS is called afcarsid).
* There will never be more than two episodes per child (i.e., variable.2) that are indexed in the AFCARS wide file, 
* since it is based on two 6-month periods and each period can have only episode.

sort cases BY ChildID DtLatRemPlus7  .
casestovars
 /ID = ChildID
 /GROUPBY = VARIABLE.


* Flag records indicating they are from AFCARS
****************************************************

* This will be used for denominator for determining the number of AFCARS matches in the NCANDS file.
compute AFCARS = 1.
execute.

* Save.
sort cases by stateabb afcarsid.
save outfile ='Temp_FH\Maltx FC 2 AFCARS wide ' + PeriodType + YYstr + '.sav'. 

****************************************************
****************************************************
* PREPARE NCANDS DATA
****************************************************
****************************************************
*Open Multiyear NCANDS file with derived variables.


get file 'NCANDS_Comb_FH\CFSR 3 NCANDS source data.zsav'
/keep subyr stateabb rptid chid rptdt chage chbdate afcarsid inciddt flvictim statetxt state.
dataset name NCANDSChild window=front.
dataset close AFCARSDuplicated.

CACHE.


** Select relevant victim records for the FY of interest from two consecutive Child Files.

select if ((subyr=YYYY or subyr = YYYY+1)) AND (RPTDT ge date.mdy(10,1,YYYY-1) and rptdt le date.mdy(9,30,YYYY)) .
execute.

select if flvictim = 1.
execute.

sort cases by stateabb chid rptdt. 
execute.
****************************************************
* Individual Level DQ - FLAG AND DROP STATES THAT EXCEED DQ LIMITS ON NCANDS DQ CHECKS
****************************************************


get file 'NCANDS_DQ_FH\Merged NCANDS IND files.sav'.
dataset name DQResults_Ind window=front.

SELECT IF subyr = YYYY.
execute.

sort cases by stateabb chid.

Dataset activate NCANDSChild.

match files 
    /FILE='NCANDSChild'
    /TABLE='DQResults_Ind' 
    /BY stateabb chid.
execute.


SELECT IF sysmis(notsamechild) OR notsamechild eq 0.
EXECUTE.


****************************************************
* SELECT APPLICABLE RECORDS 
****************************************************
* If child has a subsequent report, and it is within 1 day of his initial report, we do not count it (i.e, reports are 
* treated as 'rolled-up' into a single report).

sort cases by stateabb chid rptdt. 
compute daysdiff2 = datediff(rptdt,lag(rptdt), "days").
EXECUTE.
select if (chid ne lag(chid) or daysdiff2 gt 1).  
EXECUTE.


* Keep only records with an afcarsid. 
select if AFCARSID ne ' '.
execute.


****************************************************
* MERGE EPISODE DATA FROM AFCARS 
INTO NCANDS TO IDENTIFY CHILDREN VICTIMIZED WHILE IN CARE
****************************************************

* Merge fields from AFCARS wide file into NCANDS file. NCANDS file includes one record for every report a 
* child may have had; AFCARS file includes one record per child.
sort cases by stateabb afcarsid.
match files 
   /file = *  
   /table 'Temp_FH/Maltx FC 2 AFCARS wide ' + PeriodType + YYstr + '.sav' 
   /by stateabb afcarsid.
execute.

* Identify children victimized while in care for any of his episodes (up to two) in the 12-month period. 
* At this point, the count of victimInCare will be duplicate since a child has a record for every maltreatment report 
* during the 12-month period. When we aggregate the file later and select max(victimInCare), we will have a 
* unique count of children who were a victim in care at any point during the 12-month period. 
compute victimInCare = 0.
if (rptdt ge DtLatRemPlus7.1 and rptdt lt DtDischAdjusted2.1)victimInCare = 1.
if (rptdt ge DtLatRemPlus7.2 and rptdt lt DtDischAdjusted2.2)victimInCare = 1.

* Count victimizations. For example, if a child has three reports in NCANDS (and is a victim in each report), and 
* all three reports were reported (or the incident occurred) during the child's first episode (DtLatRemPlus7.1 
* and DtDischAdjusted2.1), victimization1 will = 1 for all three records/reports. When we aggregate the file later
* and sum the victimizations (e.g., sum(victimization1), the result will show 3 victimizations for that one episode.
compute victimization1 = 0.
compute victimization2 = 0.
if (rptdt ge DtLatRemPlus7.1 and rptdt lt DtDischAdjusted2.1)victimization1 =  1.
if (rptdt ge DtLatRemPlus7.2 and rptdt lt DtDischAdjusted2.2)victimization2  = 1.
EXECUTE.

* Incident date adjustment. Recode victimInCare to 0 and victimization.N to 0 if the incident date is present and 
* shows the child was not victimized while in care (i.e., the actual date of maltreatment was before date of latest 
* removal plus 7, or after (or the same day of) the date of discharge. 
do if ((victimization1=1) and not(missing(inciddt)) and ((inciddt lt DtLatRemPlus7.1) or (inciddt ge DtDischAdjusted2.1))).
compute adjusted=1.
compute adjustvictim1=1.
compute victimization1=0.
compute victimIncare=0.
end if.
execute.
do if ((victimization2=1) and not(missing(inciddt)) and ((inciddt lt DtLatRemPlus7.2) or (inciddt ge DtDischAdjusted2.2))).
compute adjusted=1.
compute adjustvictim2=1.
compute victimIncare=0.
compute victimization2=0.
end if.
execute.

* Restructure data from long to wide (one record per child)
****************************************************

* Current file has one record per maltreatment report during the 12-month period, so a child with three
* reports has three records. This new file will contain one record per child, with summary data from all of his 
* maltreatment reports on one record. It will contain only victims in care during the 12-month period; it will not
* contain children in care who were not victims. The file will hold variables indicating if the NCANDS child has an 
* AFCARSID in the NCANDS file (hasafcars = 1), also exists in the AFCARS file (AFCARS = 1), was a victim 
* in care at any point during the 12-month period (victimInCare = 1), and how many victimizations he had for each of up 
* to two possible foster care episodes (victimization1 and victimization2). "AFCARS" is the only variables from 
* the AFCARS file that is kept. Removed   /NCANDSvic 'Unique NCANDS victim with AFCARS ID' = max(hasafcars)

dataset declare VictimsInCare.
aggregate outfile = 'VictimsInCare'
  /break = stateabb afcarsid
  /FFY 'Federal Fiscal Year' = first (subyr)
  /AFCARSMatch 'Unique NCANDS victims with AFCARS matches' = max(AFCARS)
  /victimInCare 'Unique count of children victimized while in care'  = max(victimInCare)
  /victimization1 'victim report1' = sum(victimization1)
  /victimization2 'victim report2' = sum(victimization2).

dataset activate VictimsInCare.
dataset close NCANDSChild.

* Total up all victimizations for each child. 

compute Num_Child = sum(victimization1 to victimization2).
execute.
variable labels Num_Child 'Number of victimizations child experienced while in care across all episodes n the 12-month period'.

* Save.
save outfile = 'Temp_FH/Maltx FC 3 Unique victims in care ' + YYstr + '.sav'.

****************************************************
* MERGE VICTIMS IN CARE FROM NCANDS INTO AFCARS
****************************************************

get file = 'Temp_FH/Maltx FC 2 AFCARS wide ' + PeriodType + YYstr + '.sav'. 
dataset name Unduplicated window=front.
dataset close VictimsInCare.

* Merge data for victims in care during the 12-month period into the AFCARS file, which contains all children 
* served in the 12-month period, but no information about their victim status or presence/absense in NCANDS.
* This will merge in the following fields: FFY, NCANDSvic, AFCARSMatch, victimInCare, victimization1, 
* victimization2.
sort cases by stateabb afcarsid.
match files 
   /file = * 
   /file =  'Temp_FH/Maltx FC 3 Unique victims in care ' + YYstr + '.sav'
   /by stateabb afcarsid.
execute.

* File now includes children from NCANDS that were not in the AFCARS file (presumably because they did not 
* enter foster care and were never reported in AFCARS). These cases have blanks for all their AFCARS variables. 
* We want to get rid of these records; delete them.
select if (Den_Child ge 0).
execute.

* File now contains all children in AFCARS served during the 12-month period. If the child was also in NCANDS, 
* we have data about whether the child was a victim while in care during the period (victimInCare) and the number 
* of victimizations he experienced during his time in care (Num_Child). If the child was not in NCANDS, these 
* data are currently blank, and we assume - because the child was not reported in NCANDS - that he is not a
* victim. Populate their data accordingly to show they were in AFCARS but not in NCANDS (AFCARSMatch = 0), 
* were not an NCANDS victim (NCANDSVic = 0), were not a victimincare (victimInCare = 99), and had zero 
* victimizations (Num_Child = 0).

do if missing(FFY).
compute FFY=YYYY.
compute NCANDSVic=0.
compute victimincare=9999.
compute Num_Child=0.
end if.
execute.
missing values victimInCare (9999).


****************************************************
* SUMMARY STATISTICS
****************************************************

* Create variables holding state and national performance.
****************************************************
 
* Child-level data.
compute Perf_Child = (Num_Child / Den_Child).
compute Perf_Child_MP = (Num_Child / Den_Child) * 365.
execute.

* State-level data.
sort cases by state (A) ChildID (A).
aggregate
  /OUTFILE=* MODE=ADDVARIABLES
  /PRESORTED
  /BREAK=state
  /Num_State=SUM(Num_Child) 
  /Den_State=SUM(Den_Child)
  /N_State=N.
compute Perf_State = (Num_State / Den_State).
compute Perf_State_MP = (Num_State / Den_State) * 100000.
execute.

* National-level data.
aggregate
  /OUTFILE=* MODE=ADDVARIABLES
  /BREAK=
  /Num_Nation=SUM(Num_Child)
  /Den_Nation=SUM(Den_Child) 
  /N_Nation=N.
compute Perf_Nation = (Num_Nation / Den_Nation).
compute Perf_Nation_MP = (Num_Nation / Den_Nation) * 100000.
execute.

formats Perf_Child Perf_State Perf_Nation (F6.5).

variable labels 
Perf_Child 'Maltx in care - Victimization rate per days in care (child)'
Perf_Child_MP 'Maltx in care - Victimization rate per 365 days in care (child)'
N_State 'Number of children served in the state during the 12-month period'
Den_State 'Maltx in care denominator - Total number days children were in care in state across all episides in the 12-month period'
Num_State 'Maltx in care numerator - Total number of victimizations in state children experienced while in care across all episodes in the 12-month period'
Perf_State_MP 'Maltx in care - Victimization rate per 100,000 days in care (state)'
N_Nation 'Number of children served in the nation during the 12-month period'
Den_Nation 'Maltx in care denominator - Total number days children were in care in nation across all episides in the 12-month period'
Num_Nation 'Maltx in care numerator - Total number of victimizations in nation children experienced while in care across all episodes in the 12-month period'
Perf_Nation_MP 'Maltx in care - Victimization rate per 100,000 days in care (nation)'.


****************************************************
* OUTPUT FILES
****************************************************

* Save.
save outfile='Output_Child_FH\CFSR 3 - Observed perf for maltx in care ' + PeriodType + YYstr + '.sav'
   /compressed.

* Save file for STATA (for multi-level modeling).
* If child has two episodes during the period, use age associated with the first episode.  
rename variables (Agemosyrs.1 = ChildAge). 
save translate OUTFILE='Output_Child_FH\CFSR 3 - Observed perf for maltx in care ' + PeriodType + YYstr + '.dta'
  /TYPE=STATA
  /VERSION=8
  /EDITION=SE
  /MAP
  /REPLACE
  /KEEP=state stateabb statetxt TwelveMoCohort ChildID Num_Child Den_Child ChildAge N_State Den_State 
Num_State Perf_State Perf_State_MP N_Nation Den_Nation Num_Nation Perf_Nation Perf_Nation_MP.
rename variables (ChildAge = Agemosyrs.1). 

* Create file with one record per state holding observed performance for the 12-month cohort.
compute numstates = 1.
if (state eq lag(state))numstates = 0.
execute.

dataset copy OneRecordPerState.
dataset activate OneRecordPerState.
select if (numstates=1).
execute.
dataset activate OneRecordPerState.

string Indicator (A30).
execute.
compute Indicator = "Maltx in care".
execute.

save outfile='Output_State_FH\CFSR 3 - Observed perf for maltx in care State file ' + PeriodType + YYstr + '.sav'
   /keep state stateabb statetxt Indicator TwelveMoCohort Perf_State.

dataset activate Unduplicated.
dataset close OneRecordPerState.

* Save output.
output save OUTFILE='SpssLogs_FH\CFSR 3 - Observed perf for maltx in care ' + PeriodType + YYstr + '.spv'.

***********************************************************
ALL DONE.
***********************************************************







