﻿* Encoding: UTF-8.
* SPSS syntax to CREATE MASTER DATA FILE:
*   Creates State master '.SAV' file from validated '.TXT' file 

* Syntax File Name: CREATE_MASTER_SAV_FY2014_macro.SPS
* Instructions: Edit 'DATA LIST' command below to reference location of TXT file.
*               Select 'Run All' after making this modification.  
* Location of Data File Produced: N:\NCANDS\archive\child\childtxt\2014\Output\[STATERR]\[STATERR][YEAR]CHILD.SAV

*12-17-2010--the file creation date field (CFILEDAT) was changed to a system created date to reflect the date the child file was created.
*mjortiz.
*07-01-2013-- syntax modified to add new fields in. The time fields are converted from numeric fields to time fields (hh:mm:ss).
*mjortiz.
*2014 TXTFILE field added. This field holds the txt file name of the EVAA output file and is referenced in the macro.

*1/5/2016 Encoding added to the data list command to accomodate special characters in the AFCARS ID field.

*11/4/16 Edited variable labels to match with revised Field Long Names. Syntax has not yet been tested. 
*gshusterman.


* EDIT FILE SPECIFICATION BELOW TO REFERENCE LOCATION OF STATE VALIDATED .TXT file.
*************** GLOBALLY REPLACE FILE-NAME WITH NAME OF TEXT FILE.*****************************.
****************GLOBALLY REPLACE \BM\ WITH \STATERR\*************************************************.

*DEFINE MACRO. 


define !TEXTFILE ( ) 'FILE_NAME' !enddefine. 

DATA LIST  file = "N:\NCANDS\data_collection\2017\SPSS\BM\FILE_NAME.txt"
   encoding = 1252 /
 subyr 1-4
 staterr 5-6 (a)
 rptid 7-18 (a)
 chid 19-30 (a)
 rptcnty 31-33 
 rptdatm 34-35 
 rptdatd 36-37
 rptdaty 38-41
 invdatm 42-43 invdatd 44-45 invdaty 46-49
 rptsrc 50-51
 rptdisp 52-53
 dspdatm 54-55 dspdatd 56-57 dspdaty 58-61
 notifs 62
 chage 63-64
 dobdatm 65-66 dobdatd 67-68 dobdaty 69-72
 chsex 73
 chracai 74
 chracas 75
 chracbl 76
 chracnh 77
 chracwh 78
 chracud 79
 cethn 80
 chcnty 81-83
 chlvng 84-85
 chmil 86
 chprior 87
 chmal1 88
 mal1lev 89-90
 chmal2 91
 mal2lev 92-93
 chmal3 94
 mal3lev 95-96
 chmal4 97
 mal4lev 98-99
 maldeath 100
 cdalc 101
 cddrug 102
 cdrtrd 103
 cdemotnl 104
 cdvisual 105
 cdlearn 106
 cdphys 107
 cdbehav 108 
 cdmedicl 109
 fcalc 110
 fcdrug 111
 fcrtrd 112
 fcemotnl 113
 fcvisual 114
 fclearn 115
 fcphys 116
 fcmedicl 117
 fcviol 118
 fchouse 119
 fcmoney 120
 fcpublic 121
 postserv 122
 srvdatm 123-124 srvdatd 125-126 srvdaty 127-130
 famsup 131
 fampres 132
 fostercr 133
 rmvdatm 134-135 rmvdatd 136-137 rmvdaty 138-141 
 juvpet 142
 petdatm 143-144 petdatd 145-146 petdaty 147-150 
 cochrep 151
 adopt 152
 casemang 153
 counsel 154
 daycare 155
 educatn 156
 employ 157
 famplan 158
 health 159
 homebase 160
 housing 161
 transliv 162
 inforef 163
 legal 164
 menthlth 165
 pregpar 166
 respite 167
 ssdisabl 168
 ssdelinq 169
 subabuse 170
 transprt 171
 othersv 172
 wrkrid 173-184 (a)
 suprvid 185-196 (a)
 per1id 197-208 (a)
 per1rel 209-210 
 per1prnt 211
 per1cr 212
 per1age 213-214
 per1sex 215
 p1racai 216
 p1racas 217
 p1racbl 218
 p1racnh 219
 p1racwh 220
 p1racud 221
 per1ethn 222
 per1mil 223
 per1pior 224
 per1mal1 225
 per1mal2 226
 per1mal3 227
 per1mal4 228
 per2id 229-240 (a)
 per2rel 241-242
 per2prnt 243
 per2cr 244
 per2age 245-246
 per2sex 247
 p2racai 248
 p2racas 249
 p2racbl 250
 p2racnh 251
 p2racwh 252
 p2racud 253
 per2ethn 254
 per2mil 255
 per2pior 256
 per2mal1 257
 per2mal2 258
 per2mal3 259
 per2mal4 260
 per3id 261-272 (a)
 per3rel 273-274
 per3prnt 275
 per3cr 276
 per3age 277-278
 per3sex 279
 p3racai 280
 p3racas 281
 p3racbl 282
 p3racnh 283
 p3racwh 284
 p3racud 285
 per3ethn 286
 per3mil 287
 per3pior 288
 per3mal1 289
 per3mal2 290
 per3mal3 291
 per3mal4 292
 afcarsid 293-304 (a)
 incidm 305-306 incidd 307-308 incidy 309-312
 rpttm 313-316
 invstrtm 317-320
 deathm 321-322 deathd 323-324 deathy 325-328
 fcdchm 329-330 fcdchd 331-332 fcdchy 333-336
 strtm  337-338 strtd  339-340 strty  341-344 
 hyphen 345 (a)
 version 346-354 (a). 
freq subyr.

* Compute dates from respective month, day, year components. 
compute rptdt    = date.mdy(rptdatm,rptdatd, rptdaty)   .       
compute invdate  = date.mdy(invdatm,invdatd, invdaty) .   
compute rpdispdt = date.mdy(dspdatm,dspdatd,dspdaty) .        
compute chbdate  = date.mdy(dobdatm,dobdatd,dobdaty) .      
compute servdate = date.mdy(srvdatm,srvdatd,srvdaty) .         
compute rmvdate  = date.mdy(rmvdatm,rmvdatd,rmvdaty) .         
compute petdate  = date.mdy(petdatm,petdatd,petdaty) .   
compute inciddt  = date.mdy(incidm,incidd,incidy) .  
compute deathdt =  date.mdy(deathm,deathd,deathy). 
compute fcdchdt = date.mdy(fcdchm,fcdchd,fcdchy). 
compute strtdate = date.mdy(strtm,strtd,strty).  
compute cfiledat = 86400 * (trunc ($time / 86400)).          
format rptdt invdate rpdispdt chbdate strtdate servdate rmvdate petdate inciddt deathdt fcdchdt cfiledat
  (date9) .
compute rptyr = xdate.year(rptdt) .

*convert report time and investigation start time into time variables. This will be displayed as hh:mm:ss.
compute rpttm =TIME.HMS(trunc (rpttm/100), mod(rpttm, 100)).
compute invstrtm =TIME.HMS(trunc (invstrtm/100), mod(invstrtm, 100)).
format rpttm invstrtm (time10).
exec.

var labels  
 subyr 'Submission Year' /
 staterr 'State Territory' /
 rptid 'Report ID' /
 chid 'Child ID' /
 rptcnty 'County Of Investigation/Assessment' /
 rptdt 'Report Date' / 
 invdate 'Investigation Start Date' /
 rptsrc 'Report Source' / 
 rptdisp 'Report Disposition' / 
 rpdispdt 'Report Disposition Date' /
 notifs 'Notifications' /
 chage 'Child Age At Report' / 
 chbdate 'Child Date Of Birth' /
 chsex 'Child Sex' /
 chracai 'Child Race American Indian or Alaska Native' /
 chracas 'Child Race Asian' /
 chracbl 'Child Race Black or African American' /
 chracnh 'Child Race Native Hawaiian or Other Pacific Islander' /
 chracwh 'Child Race White' /
 chracud 'Child Race Unable to Determined' /
 cethn 'Child Hispanic or Latino Ethnicity' /
 chcnty 'County Of Residence' /
 chlvng 'Living Arrangement' /
 chmil 'Military Family Member' /
 chprior 'Prior Victim' /
 chmal1 'Maltreatment-1 Type' /
 mal1lev 'Maltreatment-1 Disposition Level' /
 chmal2 'Maltreatment-2 Type' /
 mal2lev 'Maltreatment-2 Disposition Level' /
 chmal3 'Maltreatment-3 Type' /
 mal3lev 'Maltreatment-3 Disposition Level' /
 chmal4 'Maltreatment-4 Type' /
 mal4lev 'Maltreatment-4 Disposition Level' /
 maldeath 'Maltreatment Death' /
 cdalc 'Alcohol Abuse-Child' /
 cddrug 'Drug Abuse-Child' /
 cdrtrd 'Intellectual Disability-Child ' /
 cdemotnl 'Emotional Disturbance-Child ' /
 cdvisual 'Visual Or Hearing Impairment-Child' /
 cdlearn 'Learning Disability-Child' /
 cdphys 'Physically Disabled-Child' /
 cdbehav 'Behavior Problem-Child' /
 cdmedicl 'Other Medical Condition-Child' /
 fcalc 'Alcohol Abuse-Caregiver(s)' /
 fcdrug 'Drug Abuse-Caregiver(s)' /
 fcrtrd 'Intellectual Disability-Caregiver(s)' /
 fcemotnl 'Emotional Disturbance-Caregiver(s)' /
 fcvisual 'Visually or Hearing Impaired-Caregiver(s)' /
 fclearn 'Learning Disability-Caregiver(s)' /
 fcphys 'Physically Disabled-Caregiver(s)' /
 fcmedicl 'Other Medical Condition-Caregiver(s)' /
 fcviol 'Domestic Violence' /
 fchouse 'Inadequate Housing' /
 fcmoney 'Financial Problem' /
 fcpublic 'Public Assistance' /
 postserv 'Post Investigation Services' /
 servdate 'Service Date' /
 famsup 'Family Support Services' /
 fampres 'Family Preservation Services' /
 fostercr 'Foster Care Services' /
 rmvdate 'Removal Date' /
 juvpet 'Juvenile Court Petition' /
 petdate 'Petition Date' / 
 cochrep 'Court-Appointed Representative' /
 adopt 'Adoption Services' /
 casemang 'Case Management Services' /
 counsel 'Counseling Services' /
 daycare 'Daycare Services-Child' /
 educatn 'Educational and Training Services' /
 employ 'Employment Services' /
 famplan 'Family Planning Services' /
 health 'Health-Related and Home Health Services' / 
 homebase 'Home-Based Services' /
 housing 'Housing Services' /
 transliv 'Independent and Transitional Living Services' /
 inforef 'Information and Referral Services' /
 legal 'Legal Services' /
 menthlth 'Mental Health Services' /
 pregpar 'Pregnancy and Parenting Services for Young Parents' /
 respite 'Respite Care Services' /
 ssdisabl 'Special Services-Disabilities' /
 ssdelinq 'Special Services-Juvenile Delinquent' /
 subabuse 'Substance Abuse Services' /
 transprt 'Transportation Services' /
 othersv 'Other Services' /
 wrkrid 'Worker ID' /
 suprvid 'Supervisor ID' /
 per1id 'Perpetrator-1 ID' /
 per1rel 'Perpetrator-1 Relationship' /
 per1prnt 'Perpetrator-1 As A Parent' /
 per1cr 'Perpetrator-1 As A Caregiver' /
 per1age 'Perpetrator-1 Age at Report' /
 per1sex 'Perpetrator-1 Sex' /
 p1racai 'Perpetrator-1 Race American Indian or Alaska Native' /
 p1racas 'Perpetrator-1 Race Asian' / 
 p1racbl 'Pertpetrator-1 Race Black or African American' /
 p1racnh 'Pertpetrator-1 Race Native Hawaiian or Other Pacific Islander' /
 p1racwh 'Pertpetrator-1 Race White' /
 p1racud 'Pertpetrator-1 Race Unable to Determine' /
 per1ethn 'Pertpetrator-1 Hispanic or Latino Ethnicity' /
 per1mil 'Pertpetrator-1 Military Member' /
 per1pior 'Pertpetrator-1 Prior Abuser' /
 per1mal1 'Pertpetrator-1 Maltreatment-1' /
 per1mal2 'Pertpetrator-1 Maltreatment-2' /
 per1mal3 'Pertpetrator-1 Maltreatment-3' /
 per1mal4 'Pertpetrator-1 Maltreatment-4' /
 per2id 'Pertpetrator-2 ID' /
 per2rel 'Perpetrator-2 Relationship' /
 per2prnt 'Pertpetrator-2 As A Parent' /
 per2cr 'Pertpetrator-2 As A Caregiver' /
 per2age 'Pertpetrator-2 Age At Report' /
 per2sex 'Perpetrator-2 Sex' /
 p2racai 'Perpetrator-2 Race American Indian or Alaska Native' /
 p2racas 'Perpetrator-2 Race Asian' /
 p2racbl 'Perpetrator-2 Race Black or African American' /
 p2racnh 'Perpetrator-2 Race Native Hawaiian or Other Pacific Islander' /
 p2racwh 'Perpetrator-2 Race White' /
 p2racud 'Perpetrator-2 Race Unable to Determine' / 
 per2ethn 'Perpetrator-2 Hispanic or Latino Ethnicity' /
 per2mil 'Perpetrator-2 Military Member' /
 per2pior 'Perpetrator-2 Prior Abuser' /
 per2mal1 'Perpetrator-2 Maltreatment-1' /
 per2mal2 'Perpetrator-2 Maltreatment-2' /
 per2mal3 'Perpetrator-2 Maltreatment-3' /
 per2mal4 'Perpetrator-2 Maltreatment-4' /
 per3id 'Perpetrator-3 ID' /
 per3rel 'Perpetrator-3 Relationship' /
 per3prnt 'Perpetrator-3 As A Parent' /
 per3cr 'Perpetrator-3 As A Caregiver' /
 per3age 'Perpetrator-3 Age At Report' /
 per3sex 'Perpetrator-3 Sex' /
 p3racai 'Perpetrator-3 Race American Indian or Alaska Native' /
 p3racas 'Perpetrator-3 Race Asian' /
 p3racbl 'Perpetrator-3 Race Black or African American' /
 p3racnh 'Perpetrator-3 Race Native Hawaiian or Other Pacific Islander' /
 p3racwh 'Perpetrator-3 Race White' /
 p3racud 'Perpetrator-3 Race Unable to Determine' /
 per3ethn 'Perpetrator-3 Hispanic or Latino Ethnicity' /
 per3mil 'Perpetrator-3 Military Member' / 
 per3pior 'Perpetrator-3 Prior Abuser' /
 per3mal1 'Perpetrator-3 Maltreatment-1' /
 per3mal2 'Perpetrator-3 Maltreatment-2' /
 per3mal3 'Perpetrator-3 Maltreatment-3' /
 per3mal4 'Perpetrator-3 Maltreatment-4' /
 afcarsid 'AFCARS ID'/
 inciddt  'Incident Date' /
 rpttm  'Report Time' /
 invstrtm  'Investigation Start Time'/
 deathdt  'Date of Death'/
 fcdchdt 'Foster Care Discharge Date'/
 strtdate 'Start Date for Reporting Period' /
 version  'Version of Validator' /
 cfiledat  'Child File Creation Date'.

* freq per1rel. 

value labels rptcnty
 998 'out of State'
 999 'unknown or missing'.

value labels rptsrc
  1 'social services personnel'
  2 'medical personnel'
  3 'mental health personnel'
  4 'legal, law enforcement, or criminal justice personnel'
  5 'education personnel'
  6 'child day care provider'
  7 'substitute care provider' 
  8 'alleged victim'
  9 'parent'
 10 'other relative'
 11 'friends/neighbor'
 12 'alleged perpetrator'
 13 'anonymous reporter'
 88 'other'
 99 'unknown or missing'.
* freq rptsrc. 


value labels rptdisp
  1 'substantiated'
  2 'indicated or reason to suspect'
  3 'alternative response disposition-victim'
  4 'alternative response disposition-not a victim'
  5 'unsubstantiated'
  6 'unsubstantiated due to intentionally false reporting'
  7 'closed-no finding'
 88 'other'
 99 'unknown or missing'.
* freq rptdisp.


value labels notifs
 1 'none'
 2 'police/prosecutor'
 3 'licensing agency'
 4 'both'
 8 'other'
 9 'unknown or missing'.
* freq notifs.


value labels chage
 00 'under one year'
 77 'unborn'
 99 'unknown or missing'.
* freq chage.


value labels chsex
 1 'male'
 2 'female'	
 9 'unknown or missing'.
* freq chsex.


value labels chracai
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq chracai.


value labels chracas
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq chracas.


value labels chracbl
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq chracbl.


value labels chracnh
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq chracnh.


value labels chracwh
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq chracwh.


value labels chracud
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq chracud.


value labels cethn
 1 'yes, Hispanic or Latino'
 2 'not Hispanic or Latino'
 3 'unable to determine'
 9 'unknown or missing'.
* freq cethn.


value labels chcnty
 998 'out of State'
 999 'unknown or missing'.
* freq chcnty.


value labels chlvng
 1 'married parents'
 2 'married parent and step parent'
 3 'unmarried parents '
 4 'parent and cohabitating partner '
 5 'both parents, marital status unknown'
 6 'single parent, mother only'
 7 'single parent, father only'
 8 'single parent, mother & other adult'
 9 'single parent, father & other adult'
10 'non-parent relative caregiver'
11 'non-relative caregiver' 
12 'group home or residential facility'
88 'Other setting'
99 'Unknown'.
* freq chlvng.

value labels chmil
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq chmil.


value labels chprior
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq chprior.


value labels chmal1
  1 'physical abuse'
  2 'neglect or deprivation of necessities'
  3 'medical neglect'
  4 'sexual abuse'
  5 'psychological or emotional maltreatment'
  6 'no alleged maltreatment'
  8 'other'	
  9 'unknown or missing'.
* freq chmal1.


value labels mal1lev
  1 'substantiated'
  2 'indicated or reason to suspect'
  3 'alternative response victim'
  4 'alternative response nonvictim'
  5 'unsubstantiated'
  6 'unsubstantiated due to intentionally false reporting'
  7 'closed-no finding'
  8 'no alleged maltreatment'
 88 'other'
 99 'unknown or missing'.
* freq mal1lev.


value labels chmal2
  1 'physical abuse'
  2 'neglect or deprivation of necessities'
  3 'medical neglect'
  4 'sexual abuse'
  5 'psychological or emotional maltreatment'
  8 'other'
  9 'unknown or missing'.
* freq chmal2.


value labels mal2lev
  1 'substantiated'
  2 'indicated or reason to suspect'
  3 'alternative response victim'
  4 'alternative response nonvictim'
  5 'unsubstantiated'
  6 'unsubstantiated due to intentionally false reporting'
  7 'closed-no finding'
 88 'other'
 99 'unknown or missing'.
* freq mal2lev.


value labels chmal3
 1 'physical abuse'
 2 'neglect or deprivation of necessities'
 3 'medical neglect'
 4 'sexual abuse'
 5 'psychological or emotional maltreatment'
 8 'other'
 9 'unknown or missing'.
* freq chmal3.


value labels mal3lev
  1 'substantiated'
  2 'indicated or reason to suspect'
  3 'alternative response disposition-victim'
  4 'alternative response disposition-not a victim'
  5 'unsubstantiated'
  6 'unsubstantiated due to intentionally false reporting'
  7 'closed-no finding'
 88 'other'
 99 'unknown or missing'.
* freq mal3lev. 


value labels chmal4
 1 'physical abuse'
 2 'neglect or deprivation of necessities'
 3 'medical neglect'
 4 'sexual abuse'
 5 'psychological or emotional maltreatment'
 8 'other'
 9 'unknown or missing'.
* freq chmal4.


value labels mal4lev
  1 'substantiated'
  2 'indicated or reason to suspect'
  3 'alternative response disposition-victim'
  4 'alternative response disposition-not a victim'
  5 'unsubstantiated'
  6 'unsubstantiated due to intentionally false reporting'
  7 'closed-no finding'
 88 'other'
 99 'unknown or missing'.
* freq mal4lev.


value labels maldeath
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq maldeath.


value labels cdalc
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq cdalc.


value labels cddrug
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq cddrug.


value labels cdrtrd
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq cdrtrd.


value labels cdemotnl
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq cdemotnl.


value labels cdvisual
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq cdvisual.


value labels cdlearn
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq cdlearn.


value labels cdphys
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq cdphys.


value labels cdbehav
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq cdbehav.

value labels cdmedicl
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq cdmedicl.


value labels fcalc
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fcalc.


value labels fcdrug
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fcdrug.


value labels fcrtrd
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fcrtrd.


value labels fcemotnl
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fcemotnl.


value labels fcvisual
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fcvisual.


value labels fclearn
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fclearn.

value labels fcphys
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fcphys.


value labels fcmedicl
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fcmedicl.

value labels fcviol
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fcviol.


value labels fchouse
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fchouse.

value labels fcmoney
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fcmoney.

value labels fcpublic
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fcpublic.


value labels postserv
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq postserv.


value labels famsup
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq famsup.


value labels fampres
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fampres.


value labels fostercr
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq fostercr.


value labels juvpet
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq juvpet.

value labels cochrep
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq cochrep.

value labels adopt
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq adopt.


value labels casemang
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq casemang.


value labels counsel
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq counsel.


value labels daycare
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq daycare.


value labels educatn
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq educatn.


value labels employ
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq employ.


value labels famplan
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq famplan.


value labels health
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq health.


value labels homebase
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq homebase.


value labels housing
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq housing.


value labels transliv
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq transliv.


value labels inforef
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq inforef.


value labels legal
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq legal.


value labels menthlth
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq menthlth.


value labels pregpar
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq pregpar.


value labels respite
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq respite.


value labels ssdisabl
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq ssdisabl.


value labels ssdelinq
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq ssdelinq.


value labels subabuse
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq subabuse.


value labels transprt
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq transprt.


value labels othersv
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq othersv.


value labels per1rel
  1 'parent'
  2 'other relative (non foster parent)'
  3 'relative foster parent'
  4 'nonrelative foster parent'
  5 'group home or residential facility staff'
  6 'child daycare provider'
  7 'unmarried partner of parent'
  8 'legal guardian'
  9 'other professionals'
 10 'friends or neighbors'
 33 'foster parent'
 88 'other'
 99 'unknown or missing'.
* freq per1rel.


value labels per1prnt
 1 'biological parent'
 2 'step-parent'
 3 'adoptive parent'
 8 'other parent'
 9 'unknown or missing'.
* freq per1prnt.


value labels per1cr
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq per1cr.


value labels per1age
 75 '75 years or older'
 99 'unknown or missing'.
* freq per1age.


value labels per1sex
 1 'male'
 2 'female'
 9 'unknown or missing'.
* freq per1sex.


value labels p1racai
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p1racai.


value labels p1racas
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p1racas.


value labels p1racbl
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p1racbl.


value labels p1racnh
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p1racnh.


value labels p1racwh
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p1racwh.


value labels p1racud
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq p1racud.



value labels per1ethn
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq per1ethn.


value labels per1mil
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq per1mil.


value labels per1pior
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq per1pior.


value labels per1mal1
 1 'yes' 
 2 'no'.
* freq per1mal1.


value labels per1mal2
 1 'yes'
 2 'no'.
* freq per1mal2.


value labels per1mal3
 1 'yes'
 2 'no'. 
* freq per1mal3.


value labels per1mal4
 1 'yes'
 2 'no'.
* freq per1mal4.


value labels per2rel
  1 'parent'
  2 'other relative (non foster parent)'
  3 'relative foster parent'
  4 'nonrelative foster parent'
  5 'group home or residential facility staff'
  6 'child daycare provider'
  7 'unmarried partner of parent'
  8 'legal guardian'
  9 'other professionals'
 10 'friends or neighbors'
 33 'foster parent'
 88 'other'
 99 'unknown or missing'.
* freq per2rel.


value labels per2prnt
 1 'biological parent'
 2 'step-parent'
 3 'adoptive parent'
 8 'other parent'
 9 'unknown or missing'.
* freq per2prnt.


value labels per2cr
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq per2cr.


value labels per2age
 75 '75 years or older'
 99 'unknown or missing'.
* freq per2age.


value labels per2sex
 1 'male'
 2 'female' 
 9 'unknown or missing'.
* freq per2sex.


value labels p2racai
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p2racai.


value labels p2racas
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p2racas.



value labels p2racbl
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p2racbl.


value labels p2racnh
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p2racnh.

value labels p2racwh
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p2racwh.


value labels p2racud
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq p2racud.


value labels per2ethn
 1 'yes'                    
 2 'no'                     
 3 'unable to determine'
 9 'unknown or missing'.
* freq per2ethn.



value labels per2mil
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq per2mil.



value labels per2pior
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq per2pior.


value labels per2mal1
 1 'yes'                           
 2 'no'.                         
* freq per2mal1.


value labels per2mal2
 1 'yes'                           
 2 'no'.                            
* freq per2mal2.


value labels per2mal3
 1 'yes'
 2 'no'.
* freq per2mal3.


value labels per2mal4
 1 'yes'
 2 'no'.
* freq per2mal4.


value labels per3rel
  1 'parent'
  2 'other relative (non foster parent)'
  3 'relative foster parent'
  4 'nonrelative foster parent'
  5 'group home or residential facility staff'
  6 'child daycare provider'
  7 'unmarried partner of parent'
  8 'legal guardian'
  9 'other professionals'
 10 'friends or neighbors'
 33 'foster parent'
 88 'other'
 99 'unknown or missing'.
* freq per3rel.


value labels per3prnt
 1 'biological parent'
 2 'step-parent'
 3 'adoptive parent'
 8 'other parent'
 9 'unknown or missing'.
* freq per3prnt.


value labels per3cr
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq per3cr.


value labels per3age
 75 '75 years or older'
 99 'unknown or missing'.
* freq per3age.


value labels per3sex
 1 'male'
 2 'female'
 9 'unknown or missing'.
* freq per3sex.

value labels p3racai
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p3racai.


value labels p3racas
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p3racas.


value labels p3racbl
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p3racbl.


value labels p3racnh
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p3racnh.


value labels p3racwh
 1 'yes'
 2 'no'
 3 'unable to determine'
 9 'unknown or missing'.
* freq p3racwh.


value labels p3racud
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq p3racud.


value labels per3ethn
 1 'yes'                    
 2 'no'                    
 3 'unable to determine'
 9 'unknown or missing'.
* freq per3ethn.


value labels per3mil
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq per3mil.


value labels per3pior
 1 'yes'
 2 'no'
 9 'unknown or missing'.
* freq per3pior.


value labels per3mal1
 1 'yes' 
 2 'no'.
* freq per3mal1.


value labels per3mal2
 1 'yes' 
 2 'no'.  
* freq per3mal2.


value labels per3mal3
 1 'yes'
 2 'no'.
* freq per3mal3.


value labels per3mal4
 1 'yes'
 2 'no'.
* freq per3mal4.
* freq chage.

* Sort cases before saving. 
sort cases by rptid chid. 

String txtfile (a21).
compute txtfile = !TEXTFILE.

*adjust width of AFCARS ID field.
alter type AFCARSID (a36).

save outfile = "N:\NCANDS\data_collection\2017\SPSS\BM\FILE_NAME.sav"
  /keep =
 CFILEDAT
 STRTDATE
 SUBYR   
 STATERR 
 RPTID 
 CHID  
 RPTCNTY 
 RPTDT
 INVDATE
 RPTSRC  
 RPTDISP 
 RPDISPDT
 NOTIFS  
 CHAGE   
 CHBDATE
 CHSEX  
 CHRACAI CHRACAS CHRACBL CHRACNH CHRACWH CHRACUD 
 cethn
 CHCNTY  
 CHLVNG  
 CHMIL   
 CHPRIOR 
 CHMAL1  
 MAL1LEV 
 CHMAL2  
 MAL2LEV 
 CHMAL3  
 MAL3LEV 
 CHMAL4  
 MAL4LEV 
 MALDEATH
 CDALC   
 CDDRUG  
 CDRTRD  
 CDEMOTNL
 CDVISUAL
 CDLEARN 
 CDPHYS  
 CDBEHAV 
 CDMEDICL
 FCALC   
 FCDRUG  
 FCRTRD  
 FCEMOTNL
 FCVISUAL
 FCLEARN 
 FCPHYS  
 FCMEDICL
 FCVIOL  
 FCHOUSE 
 FCMONEY 
 FCPUBLIC
 POSTSERV
 SERVDATE
 FAMSUP  
 FAMPRES 
 FOSTERCR
 RMVDATE
 JUVPET  
 PETDATE
 COCHREP
 ADOPT   
 CASEMANG
 COUNSEL 
 DAYCARE 
 EDUCATN 
 EMPLOY  
 FAMPLAN 
 HEALTH  
 HOMEBASE
 HOUSING 
 TRANSLIV
 INFOREF 
 LEGAL   
 MENTHLTH
 PREGPAR 
 RESPITE 
 SSDISABL
 SSDELINQ
 SUBABUSE
 TRANSPRT
 OTHERSV 
 WRKRID
 SUPRVID
 PER1ID
 PER1REL 
 PER1PRNT
 PER1CR  
 PER1AGE 
 PER1SEX 
 P1RACAI P1RACAS P1RACBL P1RACNH P1RACWH P1RACUD PER1ETHN
 PER1MIL 
 PER1PIOR
 PER1MAL1
 PER1MAL2
 PER1MAL3
 PER1MAL4
 PER2ID
 PER2REL 
 PER2PRNT
 PER2CR  
 PER2AGE 
 PER2SEX 
 P2RACAI P2RACAS P2RACBL P2RACNH P2RACWH P2RACUD PER2ETHN
 PER2MIL 
 PER2PIOR
 PER2MAL1
 PER2MAL2
 PER2MAL3
 PER2MAL4
 PER3ID
 PER3REL 
 PER3PRNT
 PER3CR  
 PER3AGE 
 PER3SEX 
 P3RACAI P3RACAS P3RACBL P3RACNH P3RACWH P3RACUD PER3ETHN
 PER3MIL 
 PER3PIOR
 PER3MAL1
 PER3MAL2
 PER3MAL3
 PER3MAL4 
 AFCARSID
 INCIDDT
 RPTTM
 INVSTRTM
 DEATHDT
 FCDCHDT
 VERSION
 TXTFILE.
freq staterr strtdate. 


get file ="N:\NCANDS\data_collection\2017\SPSS\BM\FILE_NAME.sav".


