﻿* Encoding: UTF-8.
*This code is designed to read in a text file containing the AFCARS fostercare data only and convert it into a SPSS data file.

*If using the text file submitted as part of an AFCARS submission (i.e. the text file that IT submitted to CB), the fostercare data should be copied out of this file, pasted into a new text
file, and saved. This saved file can then be used with this code.

*Within the AFCARS submission, the fostercare data starts on the third line of the file and continues til the $ delimiter.

*Update the below file handle to point to the text file with AFCARS Fostercare data.
FILE HANDLE JOB_INPUTFILE  /name= 'U:\Input.txt'.
*Update the below file handle to specify the desired file path and file name for the SPSS output file.
FILE HANDLE JOB_OUTPUTFILE  /name= 'U:Output.sav'.

DATA LIST FILE='JOB_INPUTFILE' encoding=1252 notable/
state 1-2 repdatyr 3-6
repdatmo 7-8 fipscode 9-13 recnumbr 14-25 (A) pedrevyr 26-29 pedrevmo 30-31
pedrevda 32-33 dobyr 34-37 dobmo 38-39 dobda 40-41 sex 42-42 amiakn 43-43
asian 44-44 blkafram 45-45 hawaiipi 46-46 white 47-47 untodetm 48-48
hisorgin 49-49  clindis 50-50 mr 51-51 vishear 52-52 phydis 53-53 emotdist 54
-54 othermed 55-55 everadpt 56-56 ageadopt 57-57 rem1yr 58-61 rem1mo 62-63
rem1da 64-65 totalrem 66-67 dlstfcyr 68-71 dlstfcmo 72-73 dlstfcda 74-75
latremyr 76-79 latremmo 80-81 latremda 82-83 remtrnyr 84-87 remtrnmo 88-89
remtrnda 90-91 cursetyr 92-95 cursetmo 96-97 cursetda 98-99 numplep 100-101
manrem 102-102 phyabuse 103-103 sexabuse 104-104 neglect 105-105 aaparent 106-106
daparent 107-107 aachild 108-108 dachild 109-109 childis 110-110 chbehprb 111-111
prtsdied 112-112 prtsjail 113-113 nocope 114-114 abandmnt 115-115 relinqsh 116-116
housing 117-117 curplset 118-118 placeout 119-119 casegoal 120-120 ctkfamst 121-121
ctk1yr 122-125 ctk2yr 126-129 prtmomyr 130-133 prtmommo 134-135 prtmomda
136-137 prtdadyr 138-141 prtdadmo 142-143 prtdadda 144-145 fosfamst 146-146
fcctk1yr 147-150 fcctk2yr 151-154 rf1amakn 155-155 rf1asian 156-156 rf1blkaa 157-157 
rf1nhopi 158-158 rf1white 159-159 rf1utod 160-160 hofcctk1 161-161 rf2amakn 162-162
rf2asian 163-163 rf2blkaa 164-164 rf2nhopi 165-165 rf2white 166-166 rf2utod 
167-167 hofcctk2 168-168 dodfcyr 169-172 dodfcmo 173-174 dodfcda 175-176
dodtrnyr 177-180 dodtrnmo 181-182 dodtrnda 183-184 disreasn 185-185 ivefc
186-186 iveaa 187-187 ivaafdc 188-188 ivdchsup 189-189 xixmedcd 190-190
ssiother 191-191 noa 192-192 fcmntpay 193-197.
EXECUTE.

* Encoding: UTF-8.

********AFCARS new race label syntax, filename: newraceFCVAL.sps ****************

VARIABLE LABELS STATE   "STATE" repdatyr   "Report End Date, Year-Element "   repdatmo "Report End Date, Month" fipscode "Local FIPS Code".
VARIABLE LABELS recnumbr "Record Number" pedrevyr "Review Date, Year" pedrevmo "Review Date, Month" pedrevda "Review Date, Day".
VARIABLE LABELS dobyr "Child Birth Date, Year" dobmo "Child Birth Date, Month" dobda "Child Birth Date, Day" sex "Child Sex".
VARIABLE LABELS amiakn "Child Race-Amer Indian/Alaska Native" asian "Child Race-Asian" blkafram "Child Race-Black/African American" hawaiipi "Child Race-Hawaiian/Pacif Islander".
VARIABLE LABELS white "Child Race-White" untodetm "Child Race-Unable to Determine".
VARIABLE LABELS Hisorgin "Child Hispanic Origin" clindis "Diagnosed Disability" mr "Mental Retardation".
VARIABLE LABELS vishear "Visually Hearing Impaired" phydis "Physically Disabled" emotdist "Emotionally Disturbed".
VARIABLE LABELS othermed "Other Diagnosed Condition" everadpt "Child Adopted" ageadopt "Age At Adoption".
VARIABLE LABELS rem1yr "First Removal Date, Year" rem1mo "First Removal Date, Month" rem1da "First Removal Date, Day".
VARIABLE LABELS totalrem "Total Number of Removals" dlstfcyr "DOD:Last FC Episode, Year" dlstfcmo "DOD:Last FC Episode, Month".
VARIABLE LABELS dlstfcda "DOD:Last FC Episode, Day" latremyr "Latest Removal Date, Year" latremmo "Latest Removal Date, Month".
VARIABLE LABELS latremda "Latest Removal Date, Day" remtrnyr "Removal Trans Date, Year".
VARIABLE LABELS remtrnmo "Removal Trans Date, Month" remtrnda "Removal Trans Date, Day".
VARIABLE LABELS cursetyr "Placement Date(Cur), Year" cursetmo "Placement Date(Cur), Month" cursetda "Placement Date(Cur), Day".
VARIABLE LABELS numplep "Prev Plcmnt Setngs(Cur Ep)".
VARIABLE LABELS manrem "Removal Manner" phyabuse "Physical Abuse".
VARIABLE LABELS sexabuse "Sexual Abuse" neglect "Neglect" aaparent "Alcohol Abuse Parent" daparent "Drug Abuse Parent".
VARIABLE LABELS aachild "Alcohol Abuse Child" dachild "Drug Abuse Child" childis "Child Disability".
VARIABLE LABELS chbehprb "Child Behavior Problem" prtsdied "Parent Death" prtsjail "Parent Incarceration".
VARIABLE LABELS nocope "Caretaker Inability Cope" abandmnt "Abandonment" relinqsh "Relinquishment" housing "Inadequate Housing".
VARIABLE LABELS curplset "Current Placement Setting" placeout "Out Of State Placement" casegoal "Most Recent Case Plan Goal".
VARIABLE LABELS ctkfamst "Caretaker Family Structure" ctk1yr "Yr of B of 1st Caretaker" ctk2yr "Yr of B 2nd Caretaker".
VARIABLE LABELS prtmomyr "TPR Mother, Year" prtmommo "TPR Mother, Month" prtmomda "TPR Mother, Day".
VARIABLE LABELS prtdadyr "TPR Father, Year" prtdadmo "TPR Father, Month" prtdadda "TPR Father, Day".
VARIABLE LABELS fosfamst "Foster Family Structure" fcctk1yr "Yr Of B 1st Foster Ctker".
VARIABLE LABELS fcctk2yr "Yr of B 2nd Foster Ctker".
VARIABLE LABELS rf1amakn "Race 1st Foster Ctker-Am Indian/Alaska Native" rf1asian "Race 1st Foster Ctker-Asian" rf1blkaa "Race 1st Foster Ctker-Black/Af Amer".
VARIABLE LABELS rf1nhopi "Race 1st Foster Ctker-Hawaii/Pacif Islander" rf1white "Race 1st Foster Ctker-White" rf1utod "Race 1st Foster Ctker-Unable to Determine".
VARIABLE LABELS hofcctk1 "His O of 1st Foster Ctker".
VARIABLE LABELS rf2amakn "Race 2nd Foster Ctker-Am Indian/Alaska Native" rf2asian "Race 2nd Foster Ctker-Asian" rf2blkaa "Race 2nd Foster Ctker-Black/Af Amer".
VARIABLE LABELS rf2nhopi "Race 2nd Foster Ctker-Hawaii/Pacif Islander" rf2white "Race 2nd Foster Ctker-White" rf2utod "Race 2nd Foster Ctker-Unable to Determine".
VARIABLE LABELS hofcctk2 "His O of 2nd Foster Ctker" dodfcyr "Discharge Year" dodfcmo "Discharge Month".
VARIABLE LABELS dodfcda "Discharge Day" dodtrnyr "Discharge Transaction Year" dodtrnmo "Discharge Transaction Month".
VARIABLE LABELS dodtrnda "Discharge Transaction Day" disreasn "Discharge Reason" ivefc "Title IVE Foster Care".
VARIABLE LABELS iveaa "Title IVE Adoption" ivaafdc "Title IVA" ivdchsup "Title IVD" xixmedcd "Title XIX".
VARIABLE LABELS ssiother "SSI" noa "None" fcmntpay "Monthly FC Payment".

 VALUE LABELS 
 /state
  01     "Alabama  "
  02    "Alaska  "
  04     "Arizona  "
  05        "Arkansas  "
  06        "California  "
  08        "Colorado  "
  09        "Connecticut  "
  10        "Delaware  "
  11        "District of Columbia  "
  12        "Florida  "
  13        "Georgia  "
  15        "Hawaii  "
  16        "Idaho  "
  17        "Illinois  "
  18        "Indiana  "
  19        "Iowa  "
  20        "Kansas  "
  21        "Kentucky  "
  22        "Louisiana  "
  23        "Maine  "
  24        "Maryland  "
  25        "Massachusetts  "
  26        "Michigan  "
  27        "Minnesota  "
  28        "Mississippi  "
  29        "Missouri  "
  30        "Montana  "
  31        "Nebraska  "
  32        "Nevada  "
  33        "New Hampshire  "
  34        "New Jersey  "
  35        "New Mexico  "
  36        "New York  "
  37        "North Carolina  "
  38        "North Dakota  "
  39        "Ohio  "
  40        "Oklahoma  "
  41        "Oregon  "
  42        "Pennsylvania  "
  43        "Navajo Nation"
  44        "Rhode Island  "
  45        "South Carolina  "
  46        "South Dakota  "
  47        "Tennessee  "
  48        "Texas  "
  49        "Utah  "
  50        "Vermont  "
  51        "Virginia  "
  53        "Washington  "
  54        "West Virginia  "
  55        "Wisconsin  "
  56        "Wyoming  "
  72        "Puerto Rico  "
/SEX
1     "Male  "
2     "Female  " 
/amiakn
  0        "Does not apply "
  1        "Applies "
/asian
  0        "Does not apply "
  1        "Applies "
/blkafram
  0        "Does not apply "
  1        "Applies "
/hawaiipi
  0        "Does not apply "
  1        "Applies "
/white
  0        "Does not apply "
  1        "Applies "
/untodetm 
  0        "Does not apply "
  1        "Applies "
/hisorgin
  0   "Not Applicable  "
  1   "Yes  "
  2    "No  "
  3    "Unable to determine  " 
/clindis
1   "Yes"
2   "No"
3   "Not Yet Determined"
/mr
0   "Condition does not apply"
1   "Condition applies"
/vishear
0   "Condition does not apply"
1   "Condition applies"
/phydis
0   "Condition does not apply"
1   "Condition applies"
/emotdist
0   "Condition does not apply"
1   "Condition applies"
/othermed
0   "Condition does not apply"
1   "Condition applies"
/everadpt
 0   "Not Applicable  "
  1   "Yes  "
  2    "No  "
  3    "Unable to determine  " 
/ageadopt
0   "Not Applicable"
1   "less than 2 years old"
2   "2-5 years old"
3   "6-12 years old"
4   "13 years or older"
5   "Unable to Determine"
/manrem
1   "Voluntary"
2   "Court Ordered"
3   "Not Yet Determined"
/phyabuse
0   "Condition does not apply"
1   "Condition applies"
/sexabuse
0   "Condition does not apply"
1   "Condition applies"
/neglect
0   "Condition does not apply"
1   "Condition applies"
/aaparent
0   "Condition does not apply"
1   "Condition applies"
/daparent
0   "Condition does not apply"
1   "Condition applies"
/aachild
0   "Condition does not apply"
1   "Condition applies"
/dachild
0   "Condition does not apply"
1   "Condition applies"
/childis
0   "Condition does not apply"
1   "Condition applies"
/chbehprb
0   "Condition does not apply"
1   "Condition applies"
/prtsdied
0   "Condition does not apply"
1   "Condition applies"
/prtsjail
0   "Condition does not apply"
1   "Condition applies"
/nocope
0   "Condition does not apply"
1   "Condition applies"
/abandmnt
0   "Condition does not apply"
1   "Condition applies"
/relinqsh
0   "Condition does not apply"
1   "Condition applies"
/housing
0   "Condition does not apply"
1   "Condition applies"
/curplset
1   "Pre-Adoptive Home"
2   "Foster Family Home (Relative)"
3   "Foster Family Home (Non-Relative)"
4   "Group Home"
5   "Institution"
6   "Supervised Independent Living"
7   "Runaway"
8   "Trial Home Visit"
/placeout
 0   "Not Applicable  "
  1   "Yes  "
  2    "No  "
  3    "Unable to determine  " 
/casegoal
1   "Reunify with Parent(s) or Principal Caretaker(s)"
2   "Live with Other Relative(s)"
3   "Adoption"
4   "Long Term Foster Care"
5   "Emancipation"
6   "Guardianship"
7   "Case Plan Goal Not Yet Established"
/ctkfamst
  0        "Not Applicable  "
  1        "Married Couple  "
  2        "Unmarried Couple  "
  3        "Single Female  "
  4        "Single Male  "
  5        "Unable to Determine  "
/fosfamst
  0        "Not Applicable  "
  1        "Married Couple  "
  2        "Unmarried Couple  "
  3        "Single Female  "
  4        "Single Male  "
  5        "Unable to Determine  "
/rf1amakn
  0        "Does not apply "
  1        "Applies "
/rf1asian
  0        "Does not apply "
  1        "Applies "
/rf1blkaa
  0        "Does not apply "
  1        "Applies "
/rf1nhopi
  0        "Does not apply "
  1        "Applies "
/rf1white
  0        "Does not apply "
  1        "Applies "
/rf1utod
  0        "Does not apply "
  1        "Applies "
/hofcctk1
  0   "Not Applicable  "
  1   "Yes  "
  2    "No  "
  3    "Unable to determine  " 
/rf2amakn
  0        "Does not apply "
  1        "Applies "
/rf2asian
  0        "Does not apply "
  1        "Applies "
/rf2blkaa
  0        "Does not apply "
  1        "Applies "
/rf2nhopi
  0        "Does not apply "
  1        "Applies "
/rf2white
  0        "Does not apply "
  1        "Applies "
/rf2utod
  0        "Does not apply "
  1        "Applies "
/hofcctk2
 0   "Not Applicable  "
  1   "Yes  "
  2    "No  "
  3    "Unable to determine  " 
/disreasn
0   "Not Applicable"
1   "Reunification with Parent(s) or Primary Caretaker(s)"
2   "Living with Other Relative(s)"
3   "Adoption"
4   "Emancipation"
5   "Guardianship"
6   "Transfer to Another Agency"
7   "Runaway"
8   "Death of Child"
/ivefc
0   "Condition does not apply"
1   "Condition applies"
/iveaa
0   "Condition does not apply"
1   "Condition applies"
/ivaafdc
0   "Condition does not apply"
1   "Condition applies"
/ivdchsup
0   "Condition does not apply"
1   "Condition applies"
/xixmedcd
0   "Condition does not apply"
1   "Condition applies"
/ssiother
0   "Condition does not apply"
1   "Condition applies"
/noa
0   "Condition does not apply"
1   "Condition applies".
EXECUTE.

SAVE OUTFILE = JOB_OUTPUTFILE.
